package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface EventGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void getSeverityBuckets( int resourceId, long begin, long end, int numBuckets, AsyncCallback<org.rhq.core.domain.event.EventSeverity[]> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void getSeverityBucketsForAutoGroup( int parentResourceId, int resourceTypeId, long begin, long end, int numBuckets, AsyncCallback<org.rhq.core.domain.event.EventSeverity[]> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void getSeverityBucketsForCompGroup( int resourceGroupId, long begin, long end, int numBuckets, AsyncCallback<org.rhq.core.domain.event.EventSeverity[]> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void findEventsByCriteria( org.rhq.core.domain.criteria.EventCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.event.Event>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void findEventCompositesByCriteria( org.rhq.core.domain.criteria.EventCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.event.composite.EventComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void deleteEventsForContext( org.rhq.core.domain.common.EntityContext context, java.util.List<java.lang.Integer> eventIds, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void purgeEventsForContext( org.rhq.core.domain.common.EntityContext context, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void getEventCountsBySeverity( int resourceId, long startDate, long endDate, AsyncCallback<java.util.Map<org.rhq.core.domain.event.EventSeverity,java.lang.Integer>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.EventGWTService
     */
    void getEventCountsBySeverityForGroup( int groupId, long startDate, long endDate, AsyncCallback<java.util.Map<org.rhq.core.domain.event.EventSeverity,java.lang.Integer>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static EventGWTServiceAsync instance;

        public static final EventGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (EventGWTServiceAsync) GWT.create( EventGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "EventGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
