package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ResourceTypeGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService
     */
    void findResourceTypesByCriteria( org.rhq.core.domain.criteria.ResourceTypeCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.ResourceType>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService
     */
    void getResourceTypesForResourceAncestors( int resourceId, AsyncCallback<java.util.ArrayList<org.rhq.core.domain.resource.ResourceType>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService
     */
    void getAllResourceTypeAncestors( int resourceTypeId, AsyncCallback<java.util.ArrayList<org.rhq.core.domain.resource.ResourceType>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService
     */
    void getResourceTypeDescendantsWithOperations( int resourceTypeId, AsyncCallback<java.util.HashMap<java.lang.Integer,java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceTypeGWTService
     */
    void getTemplateCountCompositeMap( AsyncCallback<java.util.Map<java.lang.Integer,org.rhq.core.domain.resource.composite.ResourceTypeTemplateCountComposite>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ResourceTypeGWTServiceAsync instance;

        public static final ResourceTypeGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ResourceTypeGWTServiceAsync) GWT.create( ResourceTypeGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ResourceTypeGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
